<html>
<head>
<title>OgreShaderProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderProgram_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderProgram_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderParameter_8h.html">OgreShaderParameter.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderFunction_8h.html">OgreShaderFunction.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderFunctionAtom_8h.html">OgreShaderFunctionAtom.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 <span class="keyword">namespace </span>RTShader {
<a name="l00040"></a>00040 
<a name="l00050"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html">00050</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RTShaderSystemAlloc</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="comment">// Interface.</span>
<a name="l00054"></a>00054 <span class="keyword">public</span>: 
<a name="l00056"></a>00056     <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a>              getType                     () <span class="keyword">const</span>;
<a name="l00057"></a>00057 
<a name="l00064"></a>00064     <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">UniformParameterPtr</a>     resolveAutoParameterReal    (<a class="code" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3" title="Defines the types of automatically updated values that may be bound to GpuProgram parameters...">GpuProgramParameters::AutoConstantType</a> autoType, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> data, <span class="keywordtype">size_t</span> size = 0);
<a name="l00065"></a>00065     
<a name="l00073"></a>00073     <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">UniformParameterPtr</a>     resolveAutoParameterReal    (<a class="code" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3" title="Defines the types of automatically updated values that may be bound to GpuProgram parameters...">GpuProgramParameters::AutoConstantType</a> autoType, <a class="code" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447" title="Enumeration of the types of constant we may encounter in programs.">GpuConstantType</a> type, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> data, <span class="keywordtype">size_t</span> size = 0);
<a name="l00074"></a>00074 
<a name="l00081"></a>00081     <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">UniformParameterPtr</a>     resolveAutoParameterInt     (<a class="code" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3" title="Defines the types of automatically updated values that may be bound to GpuProgram parameters...">GpuProgramParameters::AutoConstantType</a> autoType, <span class="keywordtype">size_t</span> data, <span class="keywordtype">size_t</span> size = 0);
<a name="l00082"></a>00082     
<a name="l00090"></a>00090     <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">UniformParameterPtr</a>     resolveAutoParameterInt     (<a class="code" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3" title="Defines the types of automatically updated values that may be bound to GpuProgram parameters...">GpuProgramParameters::AutoConstantType</a> autoType, <a class="code" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447" title="Enumeration of the types of constant we may encounter in programs.">GpuConstantType</a> type, <span class="keywordtype">size_t</span> data, <span class="keywordtype">size_t</span> size = 0);
<a name="l00091"></a>00091 
<a name="l00101"></a>00101     <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">UniformParameterPtr</a>     resolveParameter            (<a class="code" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447" title="Enumeration of the types of constant we may encounter in programs.">GpuConstantType</a> type, <span class="keywordtype">int</span> index, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> variability, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; suggestedName, <span class="keywordtype">size_t</span> size = 0);
<a name="l00102"></a>00102     
<a name="l00107"></a>00107     <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">UniformParameterPtr</a>     getParameterByName          (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00108"></a>00108 
<a name="l00113"></a>00113     <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">UniformParameterPtr</a>     getParameterByAutoType      (<a class="code" href="classOgre_1_1GpuProgramParameters.html#a155c886f15e0c10d2c33c224f0d43ce3" title="Defines the types of automatically updated values that may be bound to GpuProgram parameters...">GpuProgramParameters::AutoConstantType</a> autoType);
<a name="l00114"></a>00114 
<a name="l00120"></a>00120     <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">UniformParameterPtr</a>     getParameterByType          (<a class="code" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447" title="Enumeration of the types of constant we may encounter in programs.">GpuConstantType</a> type, <span class="keywordtype">int</span> index);
<a name="l00121"></a>00121 
<a name="l00124"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#a2479cc279c86c8e782b81889862f8a7b">00124</a>     <span class="keyword">const</span> <a class="code" href="group__RTShader.html#ga76848ed6c023c3fe0a5e9f25f87b78a8">UniformParameterList</a>&amp; <a class="code" href="classOgre_1_1RTShader_1_1Program.html#a2479cc279c86c8e782b81889862f8a7b" title="Get the list of uniform parameters of this program.">getParameters</a>       ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mParameters; };
<a name="l00125"></a>00125 
<a name="l00130"></a>00130     <a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>*                   createFunction              (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, <span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a147da0e3a9d408f20e8afcced1a15ccf">Function::FunctionType</a> functionType);
<a name="l00131"></a>00131 
<a name="l00135"></a>00135     <a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>*                   getFunctionByName           (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00136"></a>00136 
<a name="l00139"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#acf2a3a94886adfb88b0f85212f65c873">00139</a>     <span class="keyword">const</span> <a class="code" href="group__RTShader.html#ga911c4514bf2ca43be16f14ab628d2e87">ShaderFunctionList</a>&amp;   <a class="code" href="classOgre_1_1RTShader_1_1Program.html#acf2a3a94886adfb88b0f85212f65c873" title="Get the function list of this program.">getFunctions</a>                ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFunctions; };
<a name="l00140"></a>00140 
<a name="l00144"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#a1d51026c1bafcac0223edb1e371c5b52">00144</a>     <span class="keywordtype">void</span>                        <a class="code" href="classOgre_1_1RTShader_1_1Program.html#a1d51026c1bafcac0223edb1e371c5b52" title="Set the entry point function.">setEntryPointFunction</a>       (<a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>* <span class="keyword">function</span>) { mEntryPointFunction = <span class="keyword">function</span>; }
<a name="l00145"></a>00145 
<a name="l00147"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#a7b7f2adb8e8b565d6ca1d1893af82b76">00147</a>     <a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>*                   <a class="code" href="classOgre_1_1RTShader_1_1Program.html#a7b7f2adb8e8b565d6ca1d1893af82b76" title="Get the entry point function of this program.">getEntryPointFunction</a>       ()                   { <span class="keywordflow">return</span> mEntryPointFunction; }
<a name="l00148"></a>00148 
<a name="l00154"></a>00154     <span class="keywordtype">void</span>                        addDependency               (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; libFileName);
<a name="l00155"></a>00155 
<a name="l00157"></a>00157     <span class="keywordtype">size_t</span>                      getDependencyCount          () <span class="keyword">const</span>;
<a name="l00158"></a>00158 
<a name="l00162"></a>00162     <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;               getDependency               (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) <span class="keyword">const</span>;
<a name="l00163"></a>00163     
<a name="l00164"></a>00164 
<a name="l00168"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#a24f1c39c59041fb580260cd1a778c9eb">00168</a>     <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RTShader_1_1Program.html#a24f1c39c59041fb580260cd1a778c9eb" title="Sets whether a vertex program includes the required instructions to perform skeletal animation...">setSkeletalAnimationIncluded</a>(<span class="keywordtype">bool</span> value) { mSkeletalAnimation = value; }
<a name="l00169"></a>00169  
<a name="l00173"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#a3eaf8ab3e4b834a0ad24d70e210263cb">00173</a>     <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RTShader_1_1Program.html#a3eaf8ab3e4b834a0ad24d70e210263cb" title="Returns whether a vertex program includes the required instructions to perform skeletal animation...">getSkeletalAnimationIncluded</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSkeletalAnimation; }
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="comment">// Protected methods.</span>
<a name="l00176"></a>00176 <span class="keyword">protected</span>:
<a name="l00177"></a>00177 
<a name="l00181"></a>00181     <a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>         (<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> type);
<a name="l00182"></a>00182 
<a name="l00184"></a>00184     ~<a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>        ();
<a name="l00185"></a>00185 
<a name="l00187"></a>00187     <span class="keywordtype">void</span>                        destroyParameters   ();
<a name="l00188"></a>00188 
<a name="l00190"></a>00190     <span class="keywordtype">void</span>                        destroyFunctions    ();
<a name="l00191"></a>00191 
<a name="l00193"></a>00193     <span class="keywordtype">void</span>                        addParameter                (<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">UniformParameterPtr</a> parameter);
<a name="l00194"></a>00194         
<a name="l00196"></a>00196     <span class="keywordtype">void</span>                        removeParameter             (<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">UniformParameterPtr</a> parameter);
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="comment">// Attributes.</span>
<a name="l00200"></a>00200 <span class="keyword">protected</span>:
<a name="l00201"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#abc8a386d882d0ee62ff4ae3b0593cf11">00201</a>     <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a>                  <a class="code" href="classOgre_1_1RTShader_1_1Program.html#abc8a386d882d0ee62ff4ae3b0593cf11">mType</a>;                      <span class="comment">// Program type. (Vertex, Fragment, Geometry).</span>
<a name="l00202"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#aeae0ede3c6fdddacbd76f2fd4ded3442">00202</a>     <a class="code" href="group__RTShader.html#ga76848ed6c023c3fe0a5e9f25f87b78a8">UniformParameterList</a>            <a class="code" href="classOgre_1_1RTShader_1_1Program.html#aeae0ede3c6fdddacbd76f2fd4ded3442">mParameters</a>;                <span class="comment">// Program uniform parameters.  </span>
<a name="l00203"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#a546b86929d98f266dff4e8200fb629c6">00203</a>     <a class="code" href="group__RTShader.html#ga911c4514bf2ca43be16f14ab628d2e87">ShaderFunctionList</a>              <a class="code" href="classOgre_1_1RTShader_1_1Program.html#a546b86929d98f266dff4e8200fb629c6">mFunctions</a>;                 <span class="comment">// Function list.</span>
<a name="l00204"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#aea822dee4509c3bfc5ee8e2f69136645">00204</a>     <a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>*                       <a class="code" href="classOgre_1_1RTShader_1_1Program.html#aea822dee4509c3bfc5ee8e2f69136645">mEntryPointFunction</a>;        <span class="comment">// Entry point function for this program.   </span>
<a name="l00205"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#a04f22be521ef8873fdc6cfb7fc42aa1e">00205</a>     <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>                    <a class="code" href="classOgre_1_1RTShader_1_1Program.html#a04f22be521ef8873fdc6cfb7fc42aa1e">mDependencies</a>;              <span class="comment">// Program dependencies.</span>
<a name="l00206"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#a32c2651c973746f3cc2bfc3ad3d89b98">00206</a>     <span class="keywordtype">bool</span>                            <a class="code" href="classOgre_1_1RTShader_1_1Program.html#a32c2651c973746f3cc2bfc3ad3d89b98">mSkeletalAnimation</a>;         <span class="comment">// Skeletal animation calculation</span>
<a name="l00207"></a>00207 <span class="keyword">private</span>:
<a name="l00208"></a><a class="code" href="classOgre_1_1RTShader_1_1Program.html#ae46e120edae3a1f22dc68ebde7fbcfca">00208</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html" title="A singleton manager class that manages shader based programs.">ProgramManager</a>;
<a name="l00209"></a>00209 };
<a name="l00210"></a>00210 
<a name="l00214"></a>00214 }
<a name="l00215"></a>00215 }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 <span class="preprocessor">#endif</span>
<a name="l00218"></a>00218 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
